//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.


#include "parallel/PetscMultigridPrecon.h"

namespace AMDiS {

#ifdef HAVE_PETSC_DEV

  using namespace std;

  PetscErrorCode multigridComputeRhs(DM da, Vec x, Vec b)
  {
  }


  PetscErrorCode multigridComputeMatrix(DM da, Vec x, 
					Mat J, Mat jac, MatStructure *str)
  {
  }


  PetscMultigridPrecon::PetscMultigridPrecon()
  {}

  
  void PetscMultigridPrecon::init(KSP &ksp)
  {
    int globalDofX = 100;
    int globalDofY = 100;
    int nProc = sqrt(MPI::COMM_WORLD.Get_rank());
    int nDofsPerNode = 1000;

    DMDACreate2d(PETSC_COMM_WORLD, 
		 DMDA_BOUNDARY_NONE, DMDA_BOUNDARY_NONE,
		 DMDA_STENCIL_STAR,
		 globalDofX, globalDofY, 
		 nProc, nProc,
		 nDofsPerNode,
		 1,
		 PETSC_NULL, PETSC_NULL, &dmObj);

    DMSetFunction(dmObj, multigridComputeRhs);
    DMSetJacobian(dmObj, multigridComputeMatrix);

    KSPSetDM(ksp, dm);
  }


  void PetscMultigridPrecon::cleanUp()
  {
    DMDestroy(dmObj);
  }
#endif

}
